﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace BindingExample
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			tabControl.ItemsSource = Enumerable.Range(1, 20).Select(i =>
				new FirstNames
				{
					Name = "First Name " + i,
					People = Enumerable.Range(1, 20).Select(j =>
					new Person
					{
						FirstName = "First Name " + i,
						LastName = "Last Name " + j,
						Country = AllCountriesSouce.GetRandom()
					}).ToList()
				}).ToList();
		}
	}

	public class FirstNames
	{
		public string Name { get; set; }

		public IEnumerable<Person> People { get; set; }
	}

	public class Person : INotifyPropertyChanged
	{
		public string FirstName { get; set; }

		public string LastName { get; set; }


		private Country country;
		/// <summary>
		///     Gets or sets the name.
		/// </summary>
		public Country Country
		{
			get
			{
				return this.country;
			}
			set
			{
				if (this.country != value)
				{
					this.country = value;
					OnPropertyChanged("Country");
				}
			}
		}
        


		/// <summary>
		///     Event for INotifyPropertyChanged.
		/// </summary>
		public event PropertyChangedEventHandler PropertyChanged;

		/// <summary>
		///     Raises the INotifyPropertyChanged event.
		/// </summary>
		/// <param name="propertyName">The property to be included in the INotifyPropertyChanged EventArgs.</param>
		protected virtual void OnPropertyChanged(String propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
        
	}

	public class Country
	{
		public Country (string name, string abbr)
		{
			this.Name = name;
			this.Abbreviation = abbr;
		}

		public string Name { get; set; }

		public string Abbreviation { get; set; }
	}

		public class AllCountriesSouce
		{
			private static IList<Country> allCountries = new ObservableCollection<Country>()
			{
				new Country("Brazil", "BR"),
				new Country("Canada", "CAN"),
				new Country("Usa", "USA")
			};

			private static Random generator = new Random(123123);

			public static Country GetRandom()
			{
				return allCountries[generator.Next(3)];
			}

			public IEnumerable<Country> Countries
			{
				get
				{
					return allCountries;
				}
			}
		}
}
